<template>
  <div>
    <b-modal :centered="true" :id="idModal" title="Actualizar monto" @show="resetear" hide-footer>
      <form @submit="confirmar" @submit.prevent>
        <div class="modal-body">
          <div class="col">
            <div class="row">
              <label>Monto actual</label>
              <div class="input-group mb-3">
                <div class="input-group-prepend">
                  <span class="input-group-text">$</span>
                </div>
                <input
                  type="number"
                  step="0.01"
                  class="form-control text-center"
                  required
                  min="0"
                  max="999999999999999"
                  placeholder="Monto al día"
                  v-model="montoActualizado"
                />
              </div>
            </div>
          </div>
        </div>

        <div class="modal-footer">
          <button
            type="button"
            class="btn btn-secondary"
            data-dismiss="modal"
            @click="resetear"
          >Cancelar</button>
          <button type="submit" class="btn btn-primary">Confirmar</button>
        </div>
      </form>
    </b-modal>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";
import axios, { AxiosResponse } from "axios";
import Cartera from "./Cartera.vue";
import { Activo } from "../domain/Activo";

@Component
export default class ActualizacionMonto extends Vue {
  @Prop({ required: true }) montoActual!: String;
  @Prop({ required: true }) idActivo!: number;

  private idModal: string = "";
  private montoActualizado: string = "";

  confirmar() {
    this.actualizarUnActivo(this.idActivo, this.montoActualizado)
    this.$bvModal.hide(this.idModal);
    this.resetear();
  }

  actualizarUnActivo(idActivo: number, montoActualizado: string) {
    var activoDiario: Activo = {
      id: idActivo,
      montoActual: montoActualizado
    };
    axios
      .post("http://localhost:8097/api/movimiento", activoDiario)
      .then(() => {
        this.$emit("actualizarCartera");
      });
  }

  resetear() {
    this.montoActualizado = "";
  }

  created() {
    this.idModal = "actualizacion-monto" + this.idActivo;
  }
}
</script>

<style>
.modal-body {
  padding: 8px !important;
}
</style>